org.osgi.framework

## Class FrameworkEvent

- java.lang.Object
- - java.util.EventObject
  - - org.osgi.framework.FrameworkEvent

All Implemented Interfaces:
  Serializable

    public class FrameworkEvent
    extends EventObject

A general event from the Framework.

`FrameworkEvent` objects are delivered to `FrameworkListener`s when a general event occurs within the OSGi environment. A type code is used to identify the event type for future extendability.

OSGi Alliance reserves the right to extend the set of event types.

Author:
  $Id: bcff0614c20b454723977355f99486ca01ee89ea $
See Also:
  `FrameworkListener`, Serialized Form

### Field Summary

Fields
`static int` `ERROR` An error has occurred.
`static int` `INFO` An informational event has occurred.
`static int` `PACKAGES_REFRESHED` A FrameworkWiring.refreshBundles operation has completed.
`static int` `STARTED` The Framework has started.
`static int` `STARTLEVEL_CHANGED` A FrameworkStartLevel.setStartLevel operation has completed.
`static int` `STOPPED` The Framework has stopped.
`static int` `STOPPED_BOOTCLASSPATH_MODIFIED` Deprecated. As of 1.10.
`static int` `STOPPED_SYSTEM_REFRESHED` The Framework has stopped and the framework requires a new class loader to restart.
`static int` `STOPPED_UPDATE` The Framework has stopped during update.
`static int` `WAIT_TIMEDOUT` The Framework did not stop before the wait timeout expired.
`static int` `WARNING` A warning has occurred.

### Fields inherited from class java.util.EventObject

`source`

### Constructor Summary

Constructors
Constructor and Description
`FrameworkEvent(int type, Bundle bundle, Throwable throwable)` Creates a Framework event regarding the specified bundle.
`FrameworkEvent(int type, Object source)` Deprecated. As of 1.2. This constructor is deprecated in favor of using the other constructor with the System Bundle as the event source.

### Method Summary

All Methods Instance Methods Concrete Methods
`Bundle` `getBundle()` Returns the bundle associated with the event.
`Throwable` `getThrowable()` Returns the exception related to this event.
`int` `getType()` Returns the type of framework event.

### Methods inherited from class java.util.EventObject

`getSource, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### STARTED

    public static final int STARTED

The Framework has started.

This event is fired when the Framework has started after all installed bundles that are marked to be started have been started and the Framework has reached the initial start level. The source of this event is the System Bundle.

See Also:
  "The Start Level Specification", Constant Field Values

#### ERROR

    public static final int ERROR

An error has occurred.

There was an error associated with a bundle.

See Also:
  Constant Field Values

#### PACKAGES_REFRESHED

    public static final int PACKAGES_REFRESHED

A FrameworkWiring.refreshBundles operation has completed.

This event is fired when the Framework has completed the refresh bundles operation initiated by a call to the FrameworkWiring.refreshBundles method. The source of this event is the System Bundle.

Since:
  1.2
See Also:
  `FrameworkWiring.refreshBundles(java.util.Collection, FrameworkListener...)`, Constant Field Values

#### STARTLEVEL_CHANGED

    public static final int STARTLEVEL_CHANGED

A FrameworkStartLevel.setStartLevel operation has completed.

This event is fired when the Framework has completed changing the active start level initiated by a call to the StartLevel.setStartLevel method. The source of this event is the System Bundle.

Since:
  1.2
See Also:
  `FrameworkStartLevel.setStartLevel(int, FrameworkListener...)`, Constant Field Values

#### WARNING

    public static final int WARNING

A warning has occurred.

There was a warning associated with a bundle.

Since:
  1.3
See Also:
  Constant Field Values

#### INFO

    public static final int INFO

An informational event has occurred.

There was an informational event associated with a bundle.

Since:
  1.3
See Also:
  Constant Field Values

#### STOPPED

    public static final int STOPPED

The Framework has stopped.

This event is fired when the Framework has been stopped because of a stop operation on the system bundle. The source of this event is the System Bundle.

Since:
  1.5
See Also:
  Constant Field Values

#### STOPPED_UPDATE

    public static final int STOPPED_UPDATE

The Framework has stopped during update.

This event is fired when the Framework has been stopped because of an update operation on the system bundle. The Framework will be restarted after this event is fired. The source of this event is the System Bundle.

Since:
  1.5
See Also:
  Constant Field Values

#### STOPPED_BOOTCLASSPATH_MODIFIED

    public static final int STOPPED_BOOTCLASSPATH_MODIFIED

Deprecated. As of 1.10.
The Framework has stopped and the boot class path has changed.

This event is fired when the Framework has been stopped because of a stop operation on the system bundle and a bootclasspath extension bundle has been installed or updated. The source of this event is the System Bundle.

Since:
  1.5
See Also:
  Constant Field Values

#### WAIT_TIMEDOUT

    public static final int WAIT_TIMEDOUT

The Framework did not stop before the wait timeout expired.

This event is fired when the Framework did not stop before the wait timeout expired. The source of this event is the System Bundle.

Since:
  1.5
See Also:
  Constant Field Values

#### STOPPED_SYSTEM_REFRESHED

    public static final int STOPPED_SYSTEM_REFRESHED

The Framework has stopped and the framework requires a new class loader to restart.

This event is fired when the Framework has been stopped because of a refresh operation on the system bundle and the framework requires a new class loader to be used to restart. For example, if a framework extension bundle has been refreshed. The source of this event is the System Bundle.

Since:
  1.9
See Also:
  Constant Field Values

### Constructor Detail

#### FrameworkEvent

    public FrameworkEvent(int type,
                          Object source)

Deprecated. As of 1.2. This constructor is deprecated in favor of using the other constructor with the System Bundle as the event source.
Creates a Framework event.

Parameters:
  `type` - The event type.
  `source` - The event source object. This may not be `null`.

#### FrameworkEvent

    public FrameworkEvent(int type,
                          Bundle bundle,
                          Throwable throwable)

Creates a Framework event regarding the specified bundle.

Parameters:
  `type` - The event type.
  `bundle` - The event source.
  `throwable` - The related exception. This argument may be `null` if there is no related exception.

### Method Detail

#### getThrowable

    public Throwable getThrowable()

Returns the exception related to this event.

Returns:
  The related exception or `null` if none.

#### getBundle

    public Bundle getBundle()

Returns the bundle associated with the event. This bundle is also the source of the event.

Returns:
  The bundle associated with the event.

#### getType

    public int getType()

Returns the type of framework event.

The type values are:

- `STARTED`
- `ERROR`
- `WARNING`
- `INFO`
- `PACKAGES_REFRESHED`
- `STARTLEVEL_CHANGED`
- `STOPPED`
- `STOPPED_UPDATE`
- `WAIT_TIMEDOUT`

Returns:
  The type of state change.